/* Funktionen fr ADC Kanal des XMega */
/* Routinen im Wesentlichen von Kampi (http://kampis-elektroecke.de/?page_id=1644) */

#include <stddef.h>
#include <avr/pgmspace.h>

/* Anpassung der MultiWii calls an XMega-Gepflogenheiten, Sa */
#define analogRead(whatPin) ADCA_Conversion(&(ADCA.CH0), whatPin)

int LeseKalibrationsbyte(int Index)
{
	int result;

	NVM_CMD = NVM_CMD_READ_CALIB_ROW_gc;
	result = pgm_read_byte(Index);
	NVM_CMD = NVM_CMD_NO_OPERATION_gc;
	return(result);
}

void ADCA_Cal(void)
{
	ADCA.CALL =	LeseKalibrationsbyte(offsetof(NVM_PROD_SIGNATURES_t, ADCACAL0));
	ADCA.CALH =	LeseKalibrationsbyte(offsetof(NVM_PROD_SIGNATURES_t, ADCACAL1));
}

unsigned int ADCA_Conversion(ADC_CH_t *Channel, char Pin)
{
	//Channel->CTRL = ADC_CH_INPUTMODE_SINGLEENDED_gc;				// wird bereits in ADC_init() gesetzt
	//Channel->MUXCTRL = (Pin << 3);			//Pin A0 (beim xNQ) // wird bereits in ADC_init() gesetzt
   
	Channel->INTFLAGS = ADC_CH_CHIF_bm;		//INTFLAGS loeschen
	Channel->CTRL |= ADC_CH_START_bm;		// starte conversion
   
	while(!Channel->INTFLAGS);				// warte bis conversion beendet ist
	//debug[0] = ADCA_CH0RES;
	return Channel->RES;
	//return ADCA_CH0RES;  
}
