//===LEDs========================================================================

void Led(){

	static uint16_t Ledcount, Blinker;
	static uint8_t State;
	
	// Variablen von MultiWii auswerten
	if (buzzerFreq == 4) {		// vbat < VBATLEVEL3_3S (siehe annexCode() in IMU.c und def.c)
		Lowvoltage = 1;
	} else {
		Lowvoltage = 0;
	}
	if (f.ARMED == 0) {				// not armed -> State = 0
		State = 0;
	} else {						// if armed, State hngt von f.ACC_MODE ab
		if (f.ACC_MODE != 0) {		// Level-Mode EIN
			State = 2;				// Hover (Shrediquette-Syntax)
		} else {
			State = 1;				// Acro (Shrediquette-Syntax)
		}
	}
  
  debug[0] = State;
  debug[1] = Lowvoltage;
		
  if (Ledcount < 500) {
    Ledcount++;
    if ((Ledcount == 135) || (Ledcount == 140) || (Ledcount == 205) || (Ledcount == 210)) {       //flash LEDs
        PORTA.OUTTGL |= ((1<<PIN6) | (1<<PIN7));		// Pos-LED	//Toggle Led_vorn & Led_hinten
    }
    if (Lowvoltage == 0) {        // Spannung noch OK
      if (State > 0) {                                       //flight modes 1 & 2 get a different LED signal
        if ((Ledcount == 130) || (Ledcount == 135) || (Ledcount == 230) || (Ledcount == 235)) {       //flash LEDs
          PORTC.OUTTGL |= (1<<PIN4);	//Toggle Led_red
        }
        if ((Ledcount == 100) || (Ledcount == 105) || (Ledcount == 200) || (Ledcount == 205)) {
          PORTC.OUTTGL |= (1<<PIN5);  //Toggle Led_blue
        }
      } else {                                                   //state = 0 ==> ready for GUI connection
        if ((Ledcount == 100) || (Ledcount == 105) || (Ledcount == 200) || (Ledcount == 205) || (Ledcount == 300) || (Ledcount == 305)) {
          PORTC.OUTTGL |= ((1<<PIN4) | (1<<PIN5));	//Toggle Led_red & Led_blue
        }
      }
    }
    if (Lowvoltage == 1) {            //when battery is low, blink the LEDs in an annoying manner
      if ((Ledcount == 90) || (Ledcount == 95) || (Ledcount == 190) || (Ledcount == 195) || (Ledcount == 290) || (Ledcount == 295) || (Ledcount == 390) || (Ledcount == 395) || (Ledcount == 490) || (Ledcount == 495)) {
          PORTA.OUTTGL |= ((1<<PIN6) | (1<<PIN7));		// Pos-LEDs		//Toggle Led_vorn & Led_hinten
      }		
      if (Blinker < 30) {
        Blinker++;
      } else {
        Blinker = 1;
        PORTC.OUTTGL |= ((1<<PIN4) | (1<<PIN5));	//Toggle Led_red & Led_blue
      }
    } 
  } else {  // Ledcount ist > 500
    Ledcount = 1;
    PORTC.OUTCLR |= ((1<<PIN4) | (1<<PIN5));		//Reset Led_red & Led_blue
    // alle 500 Runden die Pos-LEDs wieder aus machen, dann kann der Rest machen was er will
    PORTA.OUTCLR |= ((1<<PIN6) | (1<<PIN7));		// LED vorne (blau) Pos-LED	//Reset Led_vorn & Led_hinten
  }
}

