/* Auswuchten der Motoren */
//'==============Motoren auswuchten====================================================
//' Empfnger wird hier bereits abgefragt (Timer und INT)
//'
//' Start der Auswucht-Routine durch Knppel- und Schalter-Voodoo:
//'
//'   0   1  0   1              SW1: Gear (DX6i)	auf 1 lt. GUI
//'      /    \                 SW2: Flap (DX6i)	auf 0 lt. GUI
//'           
//'    SW1    SW2
//'     _______       _______
//'    |   .   |     |     . |
//'  G |   |   |   N |    /  |
//'  a |   *   | + i |   *   |  Balancing starten
//'  s |       |   c |       |
//'    |_______|   k |_______|
//'      Gier          Roll
//'
//	Bedienung:
//  Start: Arm = 0, Vollgas, Arm = 1, Roll&Nick = 100%	-> rote LED AN
//  Motor whlen mit rechtem Knppel
// *Weiter mit Gas = 0 -> rote LED aus
//  Vollgas -> rote LED an, Messzyklus startet, gewhlter Motor wird von 0..80% und zurck gesteuert und stoppt wieder, rote LED aus
//  Gas = 0
//  Weiter mit Vollgas -> rote LED an, nchsten Motor auswhlen mit rechtem Knppel
//  weiter bei *
//  Wenn alle Motoren ausgewuchtet sind weiter mit Gas = 0, beide Schalter AUX1 und AUX2 auf 0 -> normaler Flugmodus


/*  SW1		rcData[AUX1]
	SW2		rcData[AUX2]
	Gas		rcData[THROTTLE]
	(Gier)	rcData[YAW]
	Nick	rcData[PITCH]
	Roll	rcData[ROLL]
	
	//Motorzuordnungen Quad   |  Layout der Leiterplatte  |  Willas BASCOM Code  |	 MWC-Belegung	|
	//vorne links  : 3        |        (1)    (2)	  	  |      (3)    (2)      |	  [0]    [3]	|
	//vorne rechts : 2        |           \  /		  	  |         \  /         |		 \  /		|
	//hinten rechts: 1        |           /  \		  	  |         /  \         |		 /  \		|
	//hinten links : 4        |        (4)    (3)	  	  |      (4)    (1)      |	  [1]	 [2]	|
*/

void output2mots(uint8_t);		// forward declaration

void balance(){
	static uint8_t whichMotor = 5;	// welcher Motor soll gewuchtet werden?
	static uint8_t enterBal = 0;	// enter balancing code
	#define OFFCHECK (MINCHECK + 50)
	
	//Knppelabfrage
	// balancing einschalten
	if (enterBal == 0) {
		if ((rcData[ROLL] > MAXCHECK) && (rcData[PITCH] > MAXCHECK) && (rcData[THROTTLE] > MAXCHECK) && (rcData[AUX1] > MAXCHECK) && (rcData[AUX2] < OFFCHECK)) {
			enterBal = 1;
			PORTA.OUTSET |= PIN7_bm;
			while ((rcData[THROTTLE] > OFFCHECK)) {
				computeRC();
				_delay_loop_2(20000);
				WDT_Reset();
			}	// warte, bis Gas wieder auf Null
			PORTA.OUTCLR |= PIN7_bm;
		}
	} 
	
	while (enterBal == 1)
	{
		while (rcData[THROTTLE] < OFFCHECK)		// Gas geben fr weiter
		{
			WDT_Reset();
			computeRC();
		}
		while (rcData[THROTTLE] > OFFCHECK)	// solange Throttle grer Null ist, kann der Motor ausgewhlt werden
		{
			PORTA.OUTSET |= PIN7_bm;
			WDT_Reset();
			computeRC();
			// whichMotor																									
			if		  ((rcData[ROLL] > MAXCHECK) && (rcData[PITCH] < OFFCHECK)) {		// rechter Knppel rechts unten		 ___
				whichMotor = 0;															//									|   |
				while ((rcData[ROLL] > MAXCHECK) && (rcData[PITCH] < OFFCHECK)) {		//									|__\|
					WDT_Reset();
					computeRC();
				}
			} else if ((rcData[ROLL] > MAXCHECK) && (rcData[PITCH] > MAXCHECK)) {		// rechter Knppel rechts oben		 ___
				whichMotor = 1;															//									|  /|
				while ((rcData[ROLL] > MAXCHECK) && (rcData[PITCH] > MAXCHECK)) {		//									|___|
					WDT_Reset();
					computeRC();
				}
			} else if ((rcData[ROLL] < OFFCHECK) && (rcData[PITCH] > MAXCHECK)) {		// rechter Knppel links oben		 ___
				whichMotor = 3;															//									|\  |
				while ((rcData[ROLL] < OFFCHECK) && (rcData[PITCH] > MAXCHECK)) {		//									|___|
					WDT_Reset();
					computeRC();
				}
			} else if ((rcData[ROLL] < OFFCHECK) && (rcData[PITCH] < OFFCHECK)) {		// rechter Knppel links unten		 ___
				whichMotor = 2;															//									|   |
				while ((rcData[ROLL] < OFFCHECK) && (rcData[PITCH] < OFFCHECK)) {		//									|/__|
					WDT_Reset();
					computeRC();
				}
			}
			serialCom();							// Ausgabe an GUI
		}
		PORTA.OUTCLR |= PIN7_bm;
		
	#define sergey_mode 1		// Auswuchten nach _Sergey_ (http://www.rcgroups.com/forums/showthread.php?s=2e752d4b7ac1f48561c1f751aec96d8e&t=1267814)
	#if sergey_mode == 1
		uint8_t speedup = 1;
		uint8_t speed = 0, i;
		uint32_t checktime = 0;
		int32_t mean_accx = 0, mean_accy = 0;
		int32_t mid_val, sum_vec, varianz, sigma;
		int16_t accx_vals[255], accy_vals[255], acc_vec[255];
		int16_t accx_min, accx_max;

		//static uint8_t vbatTimer = 0;
		//static uint8_t ind = 0;
		//uint16_t vbatRaw = 0;
		//static uint16_t vbatRawArray[8];

		while (rcData[THROTTLE] < OFFCHECK)		// Gas geben fr weiter
		{
			WDT_Reset();
			computeRC();
			serialCom();							// Ausgabe an GUI
		}

		i = 0;
		speed = 0;
		speedup = 1;
		checktime = 0;
		PORTA.OUTSET |= PIN7_bm;

		accx_min =  32000;	// vorbesetzen
		accx_max = -32000;
		
		do 	{
			// Akku messen klappt hier leider nicht. Wenn aktiviert, kracht der Rest der Routine weg :-(
			//if (! (++vbatTimer % VBATFREQ)) {		// Akkuspannung messen
				//vbatRawArray[(ind++)%8] = analogRead(V_BATPIN);
				//for (uint8_t i=0;i<8;i++) vbatRaw += (vbatRawArray[i]);
				//vbat = vbatRaw / (VBATSCALE/2);                  // result is Vbatt in 0.1V steps
			//}
			//vbat = analogRead(V_BATPIN);
			
			ACC_getADC();							// ACC-Sensoren auslesen
			mean_accx += accADC[ROLL];				// Messwerte aufsummieren 
			if (i>0) mean_accx = (mean_accx >> 1);			// und durch 2 teilen -> Mittelwert bilden. Der 1. Wert wird nur gespeichert, nicht gemittelt.
			mean_accy += accADC[PITCH];				// Messwerte aufsummieren
			if (i>0) mean_accy = (mean_accy >> 1);			// und durch 2 teilen -> Mittelwert bilden. Der 1. Wert wird nur gespeichert, nicht gemittelt.
			
			if (accx_max < accADC[ROLL]) accx_max = accADC[ROLL];	// Maximum ermitteln
			if (accx_min > accADC[ROLL]) accx_min = accADC[ROLL];	// Minimum ermitteln
			
			if ((micros() - checktime) > 20000){		// alle 10 ms
				checktime = micros();
				if (speedup == 1)
				{
					if (speed < 254)
					{	
						speed++;
						if (speed > 253) speedup = 0;	// Max Drehzahl erreicht, jetzt langsamer werden
					}
				} 
				else 
				{	// speedup = 0
					if (speed > 0) speed--;
				}
				motor[whichMotor] = (MINTHROTTLE + (speed * ((MAXTHROTTLE - MINTHROTTLE)/254)));
				motor_s[whichMotor] = (uint16_t)((uint32_t)(motor[whichMotor]) << 4) + 400;
				writeMotors();
				
				debug[2] = speed;
				i++;
			}
			debug[0] = accx_min;
			debug[1] = accx_max;

			accx_vals[i] = mean_accx;	// hier wird zwar vielfach der selbe Wert gespeichert, das ist aber ok. Mathematisch korrekt!
			accy_vals[i] = mean_accy;
			
			WDT_Reset();
			accSmooth[ROLL] = accADC[ROLL];			// fr Ausgabe an GUI
			accSmooth[PITCH] = accADC[PITCH];		// fr Ausgabe an GUI
			serialCom();							// Ausgabe an GUI
		} while ((speedup > 0) || (speed > 0));		// automatischer Messlauf zu Ende

		PORTA.OUTCLR |= PIN7_bm;
		
		motor[whichMotor] = MINCOMMAND;								// Motor stoppen
		motor_s[whichMotor] = (uint16_t)((uint32_t)(motor[whichMotor]) << 4) + 400;
		writeMotors();
		
		// Vektorsumme ber X- und Y-Werte bilden
		sum_vec = 0;
		for (i=0; i<255; i++)
		{
			acc_vec[i] = sqrt( (accx_vals[i]*accx_vals[i]) + (accy_vals[i]*accy_vals[i]) );
			sum_vec += acc_vec[i];
		}
		mid_val = sum_vec/255;
		
		varianz = 0;
		for (i=0; i<255; i++)
		{
			varianz += ((acc_vec[i] - mid_val) * (acc_vec[i] - mid_val));
		}
		varianz /= 255;
		// Standardabweichung der aufgezeichneten Messwerte bilden
		sigma = sqrt(varianz);
		
		debug[3] = (sigma);
		
		while (rcData[THROTTLE] > OFFCHECK)		// Throttle auf Null  fr weiter
		{
			WDT_Reset();
			computeRC();
			serialCom();							// Ausgabe an GUI
		}
		
		
	#else
		output2mots(whichMotor);				// Motoren ansteuern

		ACC_getADC();							// ACC-Sensoren auslesen
		//distortion = accADC[ROLL] + accADC[PITCH];	// falsche Formel!
		//debug[0] = distortion;
		accSmooth[ROLL] = accADC[ROLL];			// fr Ausgabe an GUI
		accSmooth[PITCH] = accADC[PITCH];		// fr Ausgabe an GUI
		serialCom();							// Ausgabe an GUI
	#endif

		if ((rcData[AUX1] < OFFCHECK) && (rcData[AUX2] > OFFCHECK)) {
			enterBal = 0;
			whichMotor = 5;
			output2mots(whichMotor);			
		}
	}
}

void output2mots(uint8_t welchMotor){
	
	switch (welchMotor)
	{
		case 0 :
			motor[0] = rcData[THROTTLE];
			motor[1] = MINCOMMAND;
			motor[2] = MINCOMMAND;
			motor[3] = MINCOMMAND;
		break;
		case 1 :
			motor[0] = MINCOMMAND;
			motor[1] = rcData[THROTTLE];
			motor[2] = MINCOMMAND;
			motor[3] = MINCOMMAND;
		break;
		case 2 :
			motor[0] = MINCOMMAND;
			motor[1] = MINCOMMAND;
			motor[2] = rcData[THROTTLE];
			motor[3] = MINCOMMAND;
		break;
		case 3 :
			motor[0] = MINCOMMAND;
			motor[1] = MINCOMMAND;
			motor[2] = MINCOMMAND;
			motor[3] = rcData[THROTTLE];
		break;
		case 5 :
		default:
			motor[0] = MINCOMMAND;
			motor[1] = MINCOMMAND;
			motor[2] = MINCOMMAND;
			motor[3] = MINCOMMAND;
	}

	// auf PWM skalieren
	for (uint8_t i = 0; i < MOTOR_CNT; i++) {
		motor_s[i] = (uint16_t)((uint32_t)(motor[i]) << 4) + 400;
	}
	writeMotors();	
}