/* 
 * receive.c
 * 
 * Receives the Data from the DSM2 with SUM_PPM.
 *
 * Created by Harald Sattler on 07/01/2014.
 * Based on Matthias Code
 *
 * Functions:
 *	ISR(PORTB_INT0_vect)
 *  ISR(TCC0_OVF_vect)
 *	void computeRC()
 */

/**************************************************************************************/
/***************                PPM SUM RX Pin reading             ********************/
/**************************************************************************************/
//PORTB PIN2; Hier hngt beim xNQ der SUM-PPM-Receiver dran
ISR(PORTB_INT0_vect)
{	
	//PORTA.OUTTGL |= (1<<PIN7);	// LED hinten (rot)
	rawRCData[channel] = TCC0.CNT;
	TCC0.CNT = 0;
	// rawRCData liegen zw. 561 .. 964 (average; Einzelheiten siehe unten)
	// rcValue liegen zw. 1000 ... 1500 ... 2000
	// rawRCData liegen zw. 561 .. 964 (Einzelheiten siehe unten)
	// MUSS zw. MINCHECK (1000) und MAXCHECK (1900) liegen, sonst funktioniert die ARMED-Geschichte nicht.
	// Die rawRCData werden von der IRQ-Routine mit ca. 557..969 geliefert (Werte schwanken etwas), auch je nach Kanal
	// Throttle: 554..971, Roll: 560..960, Pitch: 565..961, Yaw: 563..963, Average: 561..964
	// Faktor = MINCHECK/(AvrMax - AvrMin) = 1000/(964 - 561) = 1000/403 = 2,481

	//rcValue[channel] = (2000 - ((964 - (rawRCData[channel+1])) * 2.481));
	
	// Im Zweifelsfall muss diese Rechnung fr jeden Kanal mit seinen eigenen Werten durchgefhrt werden
	
	channel++;
	
	//PORTA.OUTTGL |= (1<<PIN7);	// LED hinten (rot)		// ca. 15 s 
}
/**************************************************************************************/
/***************        PPM SUM RX recognize end of channels       ********************/
/**************************************************************************************/
ISR(TCC0_OVF_vect){
	//PORTA.OUTTGL |= (1<<PIN7);	// LED hinten (rot)
	channel = 0;
	//PORTA.OUTTGL |= (1<<PIN7);	// LED hinten (rot)		// ca. 260 ns
}

void computeRC(){
	int8_t chan;
	
	// rawRCData liegen zw. 561 .. 964 (average; Einzelheiten siehe unten)
	// rcValue liegen zw. 1000 ... 1500 ... 2000
	// rawRCData liegen zw. 561 .. 964 (Einzelheiten siehe unten)
	// MUSS zw. MINCHECK (1000) und MAXCHECK (1900) liegen, sonst funktioniert die ARMED-Geschichte nicht.
	// Die rawRCData werden von der IRQ-Routine mit ca. 557..969 geliefert (Werte schwanken etwas), auch je nach Kanal
	// Throttle: 554..971, Roll: 560..960, Pitch: 565..961, Yaw: 563..963, Average: 561..964
	// Faktor = MINCHECK/(AvrMax - AvrMin) = 1000/(964 - 561) = 1000/403 = 2,481
	
	for (chan = 0; chan < 8; chan++) {
		switch (rcChannel[chan])
		{
			case THROTTLE: 
				rcValue[chan] = (2000 - ((968 - (rawRCData[chan+1])) * 2.415));
			break;
			default:
				rcValue[chan] = (2000 - ((961 - (rawRCData[chan+1])) * 2.515));
		}
		rcData[chan] = rcValue[rcChannel[chan]];
	}
	
	// Hier ggf. Kanle negieren, damit die Funke immer gleich eingestellt bleiben kann (fr verschiedene Modelle)
	rcData[ROLL] = (MINTHROTTLE + (MAXTHROTTLE - rcData[ROLL]));
	rcData[YAW] = (MINTHROTTLE + (MAXTHROTTLE - rcData[YAW]));
	rcData[AUX2] = (MINTHROTTLE + (MAXTHROTTLE - rcData[AUX2]));
	
	//debug[0] = rawRCData[1];
	//debug[1] = rawRCData[2];
	//debug[2] = rawRCData[3];
	//debug[3] = rawRCData[4];
}
