#ifndef _SERIAL_2_INCLUDED
#define _SERIAL_2_INCLUDED


#define  VERSION  210

/*********** RC alias *****************/
#define PIDALT     3
#define PIDPOS     4
#define PIDPOSR    5
#define PIDNAVR    6
#define PIDLEVEL   7
#define PIDMAG     8
#define PIDVEL     9 // not used currently

#define BOXACC       0
#define BOXBARO      1
#define BOXMAG       2
#define BOXCAMSTAB   3
#define BOXCAMTRIG   4
#define BOXARM       5
#define BOXGPSHOME   6
#define BOXGPSHOLD   7
#define BOXPASSTHRU  8
#define BOXHEADFREE  9
#define BOXBEEPERON  10
#define BOXLEDMAX    11 // we want maximum illumination
#define BOXLLIGHTS   12 // enable landing lights at any altitude
#define BOXHEADADJ   13 // acquire heading for HEADFREE mode

#define PIDITEMS 10
#define CHECKBOXITEMS 14

//#if defined(QUADX)
	#define MULTITYPE 3
	#define NUMBER_MOTOR     4
//#endif

#define ACC 1
#define BARO 0
#define MAG 0
#define GPS 0
#define SONAR 0

struct flags_struct {
	uint8_t OK_TO_ARM :1 ;
	uint8_t ARMED :1 ;
	uint8_t I2C_INIT_DONE :1 ; // For i2c gps we have to now when i2c init is done, so we can update parameters to the i2cgps from eeprom (at startup it is done in setup())
	uint8_t ACC_CALIBRATED :1 ;
	uint8_t NUNCHUKDATA :1 ;
	uint8_t ACC_MODE :1 ;
	uint8_t MAG_MODE :1 ;
	uint8_t BARO_MODE :1 ;
	uint8_t GPS_HOME_MODE :1 ;
	uint8_t GPS_HOLD_MODE :1 ;
	uint8_t HEADFREE_MODE :1 ;
	uint8_t PASSTHRU_MODE :1 ;
	uint8_t GPS_FIX :1 ;
	uint8_t GPS_FIX_HOME :1 ;
	uint8_t SMALL_ANGLES_25 :1 ;
	uint8_t CALIBRATE_MAG :1 ;
} f;

//#if defined(sNQ)
uint8_t PWM_PIN[8] = {6,11,3,5,9,10,11,12};   //for sNQ: lv: pin1=D3, rv: pin15=D11, rh: pin10=D6, lh: pin9=D5
static int16_t  debug[4];
static uint8_t  rcOptions[CHECKBOXITEMS];
static int16_t  gyroADC[3],accADC[3],accSmooth[3],magADC[3];
static int16_t  heading;
static uint8_t  vbat;               // battery voltage in 0.1V steps
static int16_t  headFreeModeHold;
static int32_t  EstAlt;             // in cm
static uint16_t intPowerMeterSum, intPowerTrigger1;

const char boxnames[] PROGMEM = // names for dynamic generation of config GUI
"ACC;"
"BARO;"
"MAG;"
"CAMSTAB;"
"CAMTRIG;"
"ARM;"
"GPS HOME;"
"GPS HOLD;"
"PASSTHRU;"
"HEADFREE;"
"BEEPER;"
"LEDMAX;"
"LLIGHTS;"
"HEADADJ;"
;

const char pidnames[] PROGMEM =
"ROLL;"
"PITCH;"
"YAW;"
"ALT;"
"Pos;"
"PosR;"
"NavR;"
"LEVEL;"
"MAG;"
"VEL;"
;



#endif
/*************************************************************************
 *                      E N D   O F   S O U R C E
 *************************************************************************/

